function ChunkWorld(%name)
{
	return new ScriptGroup(%name)
	{
		class = "ChunkWorld";
	};
}

function ChunkWorld::getChunk(%this, %x, %y)
{
	%x = ~~%x;
	%y = ~~%y;

	if (isObject(%this.chunk[%x, %y]))
		return %this.chunk[%x, %y];

	%chunk = new ScriptGroup()
	{
		class = "Chunk";

		x = %x;
		y = %y;
	};

	%this.chunk[%x, %y] = %chunk;
	%this.add(%chunk);

	%chunk.onChunkCreated();
	return %chunk;
}

function ChunkWorld::getBrickPosition(%this, %chunk, %x, %y, %z)
{
	%scale = 1;

	%origin = %chunk.x * %scale * 16 SPC %chunk.y * %scale * 16 SPC %scale / 2;
	%offset = %x * %scale SPC %y * %scale SPC %z * %scale;

	return vectorAdd(%origin, %offset);
}